//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{
 if(OpenDialogSMC->Execute()){
//    int lv;
/*    AnsiString s=InputBox("Szint","Szint","0");
    try{level=StrToInt(s);}catch(...){level=0;}*/
    file=OpenDialogSMC->FileName;
    if(!smc.opensmc(file)) return;
    int nlevel=Select(levels,sizeof(levels)/sizeof(levels[0]),-1,"Select level");
    if(nlevel<0||nlevel>26) return;
    level=nlevel;
    open=false;
    smc.openlevel(level);
    smc.openenv(smc.ltype=*((char*)smc.ms_smc->Memory+0x36EE+SMCHD+level));
    rm=smc.level.start_rm;
    open=true;
    kep->Width=240;
    kep->Height=192;
    DrawRoom();
//    PaintBox1->Invalidate();
//    PaintBox1Paint(NULL);
    ComboBoxTile->Enabled=true;
    ComboBoxBack->Enabled=true;
    Level1->Enabled=true;
    Caption=file;
 }
}
//---------------------------------------------------------------------------
TSMC::TSMC(){
   want_label=false;
   ms_smc=NULL;
   ms_data=NULL; ndata=0;
   bgblock=NULL; bgtile=NULL;
   fgblock=NULL; fgtile=NULL;
   ggblock=NULL; ggtile=NULL;
   pal=NULL;
   clearsel();
}
//---------------------------------------------------------------------------
TSMC::~TSMC(){
   clear();
}
//---------------------------------------------------------------------------
bool TSMC::opensmc(AnsiString s){
   {
      int fsize;
      FILE* fp=fopen(s.c_str(),"rb");
      if(!fp) return false;
      fseek(fp,0,SEEK_END);
      fsize=ftell(fp);
      fclose(fp);
      if(fsize==0x100000) SMCHD=0;
      else if(fsize==0x100200) SMCHD=0x200;
      else { ShowMessage("ROM has bad size!"); return false; }
   }
   clear();
   ms_smc=new TMemoryStream;
   ms_smc->LoadFromFile(s);
   unsigned __int32* sa,ad;
   unsigned __int16 of; unsigned char sg;
   int i,len;
   ms_smc->Position=0x20000+SMCHD;
   ndata=1;
   for(i=0;i<ndata;i++){
      ms_smc->Read(&of,2);
      ms_smc->Read(&sg,1);
      ad=(sg<<15)|(of&0x7FFF);
      if(!i){
         ndata=(ad-0x20000)/3;
         sa=new unsigned __int32[ndata+1];
      }
      sa[i]=ad;
   }
   ms_data=new TMemoryStream*[ndata];
   sa[ndata]=0x78000;
   for(i=0;i<ndata;i++){
      ms_data[i]=new TMemoryStream;
      len=sa[i+1]-sa[i];
      ms_smc->Position=sa[i]+SMCHD;
      if(len) ms_data[i]->CopyFrom(ms_smc,len);
   }
//   lastsa=sa[91];
   delete[]sa;
   return true;
}
//---------------------------------------------------------------------------
void TSMC::clear(){
   if(ms_smc){ delete ms_smc; ms_smc=NULL; }
   if(ms_data){
      for(int i=0;i<ndata;i++){
         if(ms_data[i]){ delete ms_data[i]; ms_data[i]=NULL; }
      }
      delete[]ms_data;
   }
   closeenv();
   clearsel();
}
//---------------------------------------------------------------------------
void TSMC::openlevel(int ix){
   TMemoryStream* ms=ms_data[41+ix];
   TMemoryStream* ms_level=new TMemoryStream;
//   ms->SaveToFile("dump");
   ms->Position=0;
   ms_level->SetSize(sizeof(TLevel));
   decodelevel(ms,ms_level,720); // bg
   decodelevel(ms,ms_level,720); // fg
   decodelevel(ms,ms_level,720); // md
   decodelevel(ms,ms_level,256); // block_gg
   decodelevel(ms,ms_level,256); // block_fg
   decodelevel(ms,ms_level,256); // block_ob
   decodelevel(ms,ms_level,256); // block_fl
   decodelevel(ms,ms_level,244); // ...
   decodelevel(ms,ms_level,256); // door1
   decodelevel(ms,ms_level,256); // door2
   ms_level->Position=0;
   ms_level->Read(&level,sizeof(TLevel));
   delete ms_level;
}
//---------------------------------------------------------------------------
void TSMC::decodelevel(TMemoryStream* ms_in,TMemoryStream* ms_out,int len){
   int st=ms_out->Position,end=ms_out->Position+len,i,n;
   unsigned char ch,*p; unsigned __int16 ad;
   while(ms_out->Position<end){
      ms_in->Read(&ch,1);
      if(ch&0x80){
         if(ch&0x7F) ms_out->CopyFrom(ms_in,ch&0x7F);
      }else{
         switch(ch){
            case 1: ms_in->Read(&ch,1); n=ch?ch:256; ms_in->Read(&ch,1);
               for(i=0;i<n;i++) ms_out->Write(&ch,1);
            break;
            case 2: ms_in->Read(&ch,1); n=ch?ch:256; ms_in->Read(&ch,1);
               for(i=0;i<n;i++,ch++) ms_out->Write(&ch,1);
            break;
            case 3: ms_in->Read(&ch,1); n=ch?ch:256; ms_in->Read(&ch,1);
               for(i=0;i<n;i++,ch--) ms_out->Write(&ch,1);
            break;
            case 4: ms_in->Read(&ch,1); n=ch?ch:256; ms_in->Read(&ch,1);
               p=(unsigned char*)ms_out->Memory+st+ch;
               for(i=0;i<n;i++,p++) ms_out->Write(p,1);
            break;
            case 5: ms_in->Read(&ch,1); n=ch?ch:256; ms_in->Read(&ad,2);
               p=(unsigned char*)ms_out->Memory+st+ad;
               for(i=0;i<n;i++,p++) ms_out->Write(p,1);
            break;
            default: return ShowMessage("error in decodelevel : "+IntToStr((int)ch));
         }
      }
   }
}
//---------------------------------------------------------------------------
void TSMC::openenv(int ix){
   closeenv();
   ms_data[ix*4+1]->Position=0;
   ms_data[ix*4+2]->Position=0;
   ms_data[ix*4+3]->Position=0;
   ms_data[ix*4+4]->Position=0;
   decodeenv(ms_data[ix*4+1],&bgblock,&bgtile,3,8,16,0x100,0x200,8,9);
   decodeenv(ms_data[ix*4+2],&fgblock,&fgtile,6,8,32,0x100,0x100,8,8);
   decodeenv(ms_data[ix*4+3],&ggblock,&ggtile,3,8,32,0x100,0x100,8,8);
   decodepal(ms_data[ix*4+4],&pal,256);
   pal2=new TColor[256];
   brightpal(pal,pal2,128);
}
//---------------------------------------------------------------------------
void TSMC::closeenv(){
   if(bgblock){ delete[]bgblock; bgblock=NULL; }
   if(bgtile){ delete[]bgtile; bgtile=NULL; }
   if(fgblock){ delete[]fgblock; fgblock=NULL; }
   if(fgtile){ delete[]fgtile; fgtile=NULL; }
   if(ggblock){ delete[]ggblock; ggblock=NULL; }
   if(ggtile){ delete[]ggtile; ggtile=NULL; }
   if(pal){ delete[]pal; pal=NULL; }
   if(pal2){ delete[]pal2; pal2=NULL; }
}
//---------------------------------------------------------------------------
void TSMC::decodeenv(TMemoryStream* ms_in,unsigned __int16**block,unsigned char**tile,int wh,int hh,int si,int nb,int nt,int Bib,int Bit){
   unsigned __int16 n,*ar,*bl; unsigned char *ti;
   ms_in->Read(&n,2);
   ar=new unsigned __int16[nb];
   bl=new unsigned __int16[n*wh*hh];
   decodearray(ms_in,nb,Bib,ar);
   decodeblock(ms_in,n,wh*hh,bl);
   *block=new unsigned __int16[nb*wh*hh];
   for(int i=0;i<nb;i++){
      memcpy(*block+i*wh*hh,bl+ar[i]*wh*hh,wh*hh*2);
   }
   delete[]ar;
   delete[]bl;
/*   {
      FILE* fp;
      fp=fopen("dumpbgbl","wb");
      fwrite(bgblock,0x100,8*3*2,fp);
      fflush(fp); fclose(fp);
   }*/
   ms_in->Read(&n,2);
   ar=new unsigned __int16[nt];
   ti=new unsigned char[n*si];
   decodearray(ms_in,nt,Bit,ar);
   if(si==16) decodetile16(ms_in,n,ti);
   if(si==32) decodetile32(ms_in,n,ti);
   *tile=new unsigned char[nt*si];
   for(int i=0;i<nt;i++){
      memcpy(*tile+i*si,ti+ar[i]*si,si);
   }
   delete[]ar;
   delete[]ti;
/*   {
      FILE* fp;
      fp=fopen("dumpbgti","wb");
      fwrite(bgtile,0x200,16,fp);
      fflush(fp); fclose(fp);
   }*/
}
//---------------------------------------------------------------------------
void TSMC::decodearray(TMemoryStream* ms,int n,int Bi,unsigned __int16* ar){
   int ix=0,m1=(1<<Bi)-1,m2=(1<<(15-Bi))-1,m3=(1<<(14-Bi))-1,st,ln,
      z1=1<<(15-Bi),z2=1<<(14-Bi),i;
   unsigned __int16 _16;
   while(ix<n){
      ms->Read(&_16,2);
      if(_16&0x8000){
         st=_16&m1; ln=(_16>>Bi)&m2; if(!ln)ln=z1;
         for(i=0;i<ln;i++) ar[ix++]=st++;
      }else{
         st=_16&m1; ln=(_16>>Bi)&m3; if(!ln)ln=z2;
         if(_16&0x4000){
            for(i=0;i<ln;i++) ar[ix++]=st;
         }else{
            ar[ix++]=st;
         }
      }
   }
}
//---------------------------------------------------------------------------
void TSMC::decodeblock(TMemoryStream* ms,int n,int si,unsigned __int16* ar){
   int ix=0,m,i;
   unsigned char ch; unsigned __int16 ti;
   while(ix<n*si){
      ms->Read(&ch,1);
      if(ch&0x20){
         if((ch&0xC0)==0x00){
            m=ch-0x20; if(!m){ ms->Read(&ch,1); m=ch; }
            ms->Read(&ch,1); ti=ch<<8; ms->Read(&ch,1); ti+=ch;
            for(i=0;i<m;i++) ar[ix++]=ti;
         }else if((ch&0xC0)==0x40){
            m=ch-0x60; if(!m){ ms->Read(&ch,1); m=ch; }
            ms->Read(&ch,1); ti=ch<<8; ms->Read(&ch,1); ti+=ch;
            for(i=0;i<m;i++) ar[ix++]=ti++;
         }else if((ch&0xC0)==0x80){
            m=ch-0xA0;
            ar[ix++]=ar[ix-ix%si+m];
         }else if((ch&0xC0)==0xC0){
            m=ch-0xE0+0x20;
            ar[ix++]=ar[ix-ix%si+m];
         }
      }else{
         ti=ch<<8; ms->Read(&ch,1); ti+=ch; ar[ix++]=ti;
      }
   }
}
//---------------------------------------------------------------------------
void TSMC::decodetile16(TMemoryStream* ms,int n,unsigned char* ar){
   int ix=0,m,i;
   unsigned char ch,ch2,ti[16],is[16]; unsigned __int16 _16;
#define R(x) ms->Read(&(x),1);
#define RR(x) ms->Read(&(x),2);
#define I(x) for(i=0;i<(x);i++)
#define M1(x) if(m&1<<x)
#define M0(x) if(!(m&1<<x))
#define readallb I(16)R(ti[i]);
#define fillallb R(ch)I(16)ti[i]=ch;
#define fillall2b R(ch)R(ch2)I(8){ti[i*2]=ch;ti[i*2+1]=ch2;}
#define readallb2 I(8){R(ch);ti[i*2]=ti[i*2+1]=ch;}
#define fillb2 R(ch);m=ch;R(ch);I(8)M1(i){ti[i*2]=ti[i*2+1]=ch;is[i*2]=is[i*2+1]=true;}
#define readr2 I(8)if(!is[i*2]){R(ch);ti[i*2]=ti[i*2+1]=ch;}
#define fill2b R(ch);m=ch;R(ch)R(ch2)I(8)M1(i){ti[i*2]=ch;ti[i*2+1]=ch2;is[i*2]=is[i*2+1]=true;}
#define readr I(16)if(!is[i]){R(ti[i]);}
#define readallb_(O) I(8)R(ti[i*2+O]);
#define fillb_(O) R(ch);m=ch;R(ch);I(8)M1(i){ti[i*2+O]=ch;is[i*2+O]=true;}
#define readr_(O) I(8)if(!is[i*2+O]){R(ti[i*2+O]);}
#define readb RR(_16);m=_16;I(16)M0(i){R(ti[i]);is[i]=true;}
#define setr(x) I(16)if(!is[i]){ti[i]=x;}
#define rept RR(_16);I(16){ti[i]=ar[_16*16+i];}
#define read2b R(ch);m=ch;I(8)M0(i){R(ti[i*2]);R(ti[i*2+1]);is[i*2]=is[i*2+1]=true;}
   while(ix<n){
      ms->Read(&ch,1);
      for(i=0;i<16;i++)is[i]=false;
      switch(ch){
         case 0x00: readallb; break;
         case 0x01: fillallb; break;
         case 0x02: fillall2b; break;
         case 0x03: readallb2; break;
         case 0x04: fillb2; readr2; break;
         case 0x05: fillb2; fillb2; readr2; break;
         case 0x06: fill2b; readr; break;
         case 0x07: fill2b; fill2b; readr; break;
         case 0x08: fill2b; fill2b; fill2b; readr; break;
         case 0x09: fill2b; fill2b; fill2b; fill2b; /*readr;*/ break;
         case 0x0A: readallb_(0); fillb_(1); fillb_(1); readr_(1); break;
         case 0x0B: fillb_(0); readr_(0); fillb_(1); fillb_(1); readr_(1); break;
         case 0x0C: fillb_(0); fillb_(0); readr_(0); readr_(1); break;
         case 0x0D: fillb_(0); fillb_(0); readr_(0); fillb_(1); readr_(1); break;
         case 0x0E: fillb_(0); fillb_(0); readr_(0); fillb_(1); fillb_(1); readr_(1); break;
         case 0x10: readb; setr(0x00); break;
         case 0x11: readb; setr(0x55); break;
         case 0x12: readb; setr(0xAA); break;
         case 0x13: readb; setr(0xFF); break;
         case 0x14: rept; read2b; break;
         default: return ShowMessage("error in decodetile16 : "+IntToStr((int)ch));
      }
      for(i=0;i<16;i++)ar[ix*16+i]=ti[i];
      ix++;
   }
}
//---------------------------------------------------------------------------
void TSMC::decodetile32(TMemoryStream* ms,int n,unsigned char* ar){
   int ix=0,m,i;
   unsigned char ch,ch2,ch3,ch4,ti[32],is[32]; unsigned __int16 _16;
#define readall_b I(32)R(ti[i]);
#define fillall_b R(ch)I(32)ti[i]=ch;
#define fillall4b R(ch)R(ch2)R(ch3)R(ch4)I(8){ti[i*2]=ch;ti[i*2+1]=ch2;ti[i*2+16]=ch3;ti[i*2+17]=ch4;}
#define fill4b R(ch);m=ch;R(ch)R(ch2)R(ch3)R(ch4)I(32)M1(i){ti[i*2]=ch;ti[i*2+1]=ch2;ti[i*2+16]=ch3;ti[i*2+17]=ch4;is[i*2]=is[i*2+1]=is[i*2+16]=is[i*2+17]=true;}
#define read4r I(8)if(!is[i*2]){R(ti[i*2]);R(ti[i*2+1]);R(ti[i*2+16]);R(ti[i*2+17]);}
#define read_vsp R(ch);m=ch;I(8)M1(i){R(ch);ti[i*2]=(ch&3)*0x55;ti[i*2+1]=(ch>>2&3)*0x55;ti[i*2+16]=(ch>>4&3)*0x55;ti[i*2+17]=(ch>>6&3)*0x55;}else{R(ti[i*2]);R(ti[i*2+1]);R(ti[i*2+16]);R(ti[i*2+17]);}
#define readb_(O) R(ch2);R(ch);m=ch;I(8)M0(i)R(ti[i*2+O])else ti[i*2+O]=ch2;
#define readball_(O) I(8)R(ti[i*2+O]);
#define rept_ R(ch);I(32){ti[i]=ar[ch*32+i];}
#define read_2b R(ch);m=ch;I(8)M0(i){R(ti[i*2]);R(ti[i*2+1]);R(ti[i*2+16]);R(ti[i*2+17]);is[i*2]=is[i*2+1]=is[i*2+16]=is[i*2+17]=true;}
//#define set_r(x) I(32)if(!is[i]){ti[i]=/*x*/0xFF;}
   while(ix<n){
      ms->Read(&ch,1);
      for(i=0;i<32;i++)is[i]=false;
      switch(ch){
         case 0x00: readall_b; break;
         case 0x01: fillall_b; break;
         case 0x02: fillall4b; break;
         case 0x03: fill4b; read4r; break;
         case 0x04: fill4b; fill4b; read4r; break;
         case 0x05: fill4b; fill4b; fill4b; read4r; break;
         case 0x06: fill4b; fill4b; fill4b; fill4b; read4r; break;
         case 0x08: read_vsp; break;
         case 0x09: readb_(0); readball_(1); readball_(16); readball_(17); break;
         case 0x0A: readball_(0); readb_(1); readball_(16); readball_(17); break;
         case 0x0B: readb_(0); readb_(1); readball_(16); readball_(17); break;
         case 0x0C: readball_(0); readball_(1); readb_(16); readball_(17); break;
         case 0x0D: readb_(0); readball_(1); readb_(16); readball_(17); break;
         case 0x0E: readball_(0); readb_(1); readb_(16); readball_(17); break;
         case 0x0F: readb_(0); readb_(1); readb_(16); readball_(17); break;
         case 0x10: readball_(0); readball_(1); readball_(16); readb_(17); break;
         case 0x11: readb_(0); readball_(1); readball_(16); readb_(17); break;
         case 0x12: readball_(0); readb_(1); readball_(16); readb_(17); break;
         case 0x13: readb_(0); readb_(1); readball_(16); readb_(17); break;
         case 0x14: readball_(0); readball_(1); readb_(16); readb_(17); break;
         case 0x15: readb_(0); readball_(1); readb_(16); readb_(17); break;
         case 0x16: readball_(0); readb_(1); readb_(16); readb_(17); break;
         case 0x17: readb_(0); readb_(1); readb_(16); readb_(17); break;
         case 0x18: rept_; read_2b; /*set_r(0x00);*/ break;
         default: return ShowMessage("error in decodetile32 : "+IntToStr((int)ch));
      }
      for(i=0;i<32;i++)ar[ix*32+i]=ti[i];
      ix++;
   }
}
//---------------------------------------------------------------------------
void TSMC::drawroom(Graphics::TBitmap* bm,int rm){
   bm->Canvas->Brush->Color=pal[0];
   bm->Canvas->Rectangle(0,0,bm->Width,bm->Height);
   drawlayer(bm,level.bg[rm],3,8,16,bgblock,bgtile,NULL,0x00,NULL);
   int rm2=level.rm_links[rm][0];
   if(rm2<24){
      for(int i=0;i<3;i++){
         drawblock(bm,-24,i*64,level.block_fg[level.fg[rm2][i][9]],6,8,32,fgblock,fgtile,0x60,false);
         drawanobj(bm,-24,i*64,level.block_ob[level.fg[rm2][i][9]],false);
      }
   }else{
      for(int i=0;i<3;i++){
         drawblock(bm,-24,i*64,level.block_fg[255],6,8,32,fgblock,fgtile,0x60,false);
      }
   }
   drawlayer(bm,level.fg[rm],6,8,32,fgblock,fgtile,level.block_fg,0x60,level.block_ob);
   drawlayer(bm,level.fg[rm],3,8,32,ggblock,ggtile,level.block_gg,0x20,NULL);
   int i,j,x;
   kep->Canvas->Brush->Color=clWhite;
   kep->Canvas->Pen->Color=clBlack;
   if(want_label){
      for(i=0;i<3;i++){
         for(j=0;j<10;j++){
            x=level.block_ob[level.fg[rm][i][j]];
            if(x){
               if(x<sizeof(ob)/sizeof(ob[0])) kep->Canvas->TextOutA(j*24,i*64,ob[x]);
               else kep->Canvas->TextOutA(j*24,i*64,IntToHex(x,2));
            }
            if(x=level.md[rm][i][j]) kep->Canvas->TextOutA(j*24,i*64+32,IntToHex(x,2));
         }
      }
   }
   if((x=smc.level.guard_ps[rm])<30){
      i=x/10; j=x%10;
      x=smc.level.guard_tp[rm];
      bool f=x&0x80; x&=0x7F;
      if(want_label){
         AnsiString s;
         if(x<sizeof(gu)/sizeof(gu[0])) s=gu[x]; else s=IntToHex(x,2);
         if(f) s="<"+s; else s=s+">";
         kep->Canvas->TextOutA(j*24,i*64+16,s);
      }
      if(x<sizeof(gu_sp)/sizeof(gu_sp[0])&&x<sizeof(gu_pl)/sizeof(gu_pl[0])){
         if(gu_sp[x]>=0&&gu_pl[x]>=0){
            smc.drawsprite(kep,j*24+16,i*64+16,gu_sp[x],gu_pl[x],!f,sel[i][j]);
         }
      }
   }
   if(rm==smc.level.start_rm){
      x=smc.level.start_ps;
      i=x/10; j=x%10;
      if(want_label) kep->Canvas->TextOutA(j*24,i*64+16,smc.level.start_dr?"<start":"start>");
      smc.drawsprite(kep,j*24+16,i*64+16,14,0,!smc.level.start_dr,sel[i][j]);
   }
}
//---------------------------------------------------------------------------
void TSMC::drawlayer(Graphics::TBitmap* bm,unsigned char dt[3][10],int wh,int hh,int si,unsigned __int16* block,unsigned char* tile,unsigned char* xlat,unsigned char r0,unsigned char* xlat2){
   int i,j,x;
   for(i=0;i<3;i++){
      for(j=0;j<10;j++){
         x=dt[i][j];
         drawblock(bm,j*24,i*64,xlat?xlat[x]:x,wh,hh,si,block,tile,r0,sel[i][j]);
         if(xlat2) drawanobj(bm,j*24,i*64,xlat2[x],sel[i][j]);
      }
   }
}
//---------------------------------------------------------------------------
void TSMC::drawblock(Graphics::TBitmap* bm,int x0,int y0,int ix,int wh,int hh,int si,unsigned __int16* block,unsigned char* tile,unsigned char r0,bool sel){
   int s,o;
   for(s=0;s<hh;s++){
      for(o=0;o<wh;o++){
         drawtile(bm,x0+o*8,y0+s*8,block[ix*wh*hh+s*wh+o],si,tile,r0,sel);
      }
   }
}
//---------------------------------------------------------------------------
void TSMC::drawtile(Graphics::TBitmap* bm,int x0,int y0,int ix,int si,unsigned char* tile,unsigned char r0,bool sel){
   int s,o,i,j;
   int fx=ix&0x4000?7:0,fy=ix&0x8000?7:0,r=r0+((ix>>10&7)<<(si>>3)),ti=ix&0x3FF,l=si>>4;
   unsigned char d[8][8];
   for(s=0;s<8;s++) for(o=0;o<8;o++) d[s][o]=0;
   for(i=0;i<l;i++){
      for(s=0;s<8;s++){
         for(j=0;j<2;j++){
            for(o=0;o<8;o++){
               if(tile[ti*si+(i<<4)+(s<<1)+j]&128>>o) d[s][o]|=1<<((i<<1)+j);
            }
         }
      }
   }
   for(s=0;s<8;s++){
      for(o=0;o<8;o++){
         if(d[s][o]) bm->Canvas->Pixels[x0+(o^fx)][y0+(s^fy)]=(sel?pal2:pal)[d[s][o]+r];
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
 kep=new Graphics::TBitmap;
 kep->Width=240;
 kep->Height=192;
 Level1->Enabled=false;
 AnsiString s;
 for(int i=0;i<256;i++){
    s=IntToHex(i,2);
    ComboBoxTile->Items->Add(s);
    ComboBoxBack->Items->Add(s);
    ComboBoxFg->Items->Add(s);
    ComboBoxGg->Items->Add(s);
    ComboBoxMod->Items->Add(s);
 }
 for(int i=0;i<sizeof(ob)/sizeof(ob[0]);i++){
    ComboBoxOb->Items->Add(ob[i]);
 }
 open=false;
 Automatic1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 delete kep;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBox1Paint(TObject *Sender)
{
   PaintBox1->Width=kep->Width*scale;
   PaintBox1->Height=kep->Height*scale;
   if(scale==1){
      PaintBox1->Canvas->Draw(0,0,kep);
   }else{
      PaintBox1->Canvas->StretchDraw(TRect(0,0,PaintBox1->Width,PaintBox1->Height),kep);
   }
}
//---------------------------------------------------------------------------
void TSMC::decodepal(TMemoryStream* ms,TColor**pal,int ln){
   unsigned __int16 _16; int i;
   *pal=new TColor[ln];
   for(i=0;i<ln;i++){
      ms->Read(&_16,2);
      (*pal)[i]=RGB(_16&0x1F,_16>>5&0x1F,_16>>10&0x1F)<<3;
   }
}
//---------------------------------------------------------------------------
void TSMC::brightpal(TColor*pal,TColor*/***/pal2,int ln){
   //*pal2=new TColor[ln];
   for(int i=0;i<ln;i++) (/***/pal2)[i]=(pal[i]>>1)|0x808080;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonLeftClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[rm][0];
 if(rm2<=23){ rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonRightClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[rm][1];
 if(rm2<=23){ rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonUpClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[rm][2];
 if(rm2<=23){ rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonDownClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[rm][3];
 if(rm2<=23){ rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------
void TForm1::DrawRoom(){
   smc.drawroom(kep,rm);
   ButtonLeft->Enabled=smc.level.rm_links[rm][0]<24;
   ButtonRight->Enabled=smc.level.rm_links[rm][1]<24;
   ButtonUp->Enabled=smc.level.rm_links[rm][2]<24;
   ButtonDown->Enabled=smc.level.rm_links[rm][3]<24;
   ButtonLeft->Caption=smc.level.rm_links[rm][0];
   ButtonRight->Caption=smc.level.rm_links[rm][1];
   ButtonUp->Caption=smc.level.rm_links[rm][2];
   ButtonDown->Caption=smc.level.rm_links[rm][3];
   PaintBox1->OnPaint(NULL);
   AnsiString s;
   s.printf("%s, room %d, tile %d",levels[level],rm,lasti*10+lastj);
   StatusBar1->SimpleText=s;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(!open) return;
   int i=Y/(64*scale),j=X/(24*scale);
   lasti=i; lastj=j;
   if(Shift.Contains(ssCtrl)){
      smc.sel[i][j]^=true;
   }else{
      smc.clearsel();
      smc.sel[i][j]=true;
   }
   ComboBoxTile->ItemIndex=smc.level.fg[rm][i][j];
   ComboBoxBack->ItemIndex=smc.level.bg[rm][i][j];
   ComboBoxMod->ItemIndex=smc.level.md[rm][i][j];
   GetTile(smc.level.fg[rm][i][j]);
   GetMod(smc.level.md[rm][i][j]);
   ComboBoxFg->ItemIndex=smc.level.block_fg[smc.level.fg[rm][i][j]];
   ComboBoxGg->ItemIndex=smc.level.block_gg[smc.level.fg[rm][i][j]];
   ComboBoxOb->ItemIndex=smc.level.block_ob[smc.level.fg[rm][i][j]];
   DrawRoom();
}
//---------------------------------------------------------------------------
void TForm1::GetTile(int ix){
   ComboBoxFg->ItemIndex=smc.level.block_fg[ix];
   ComboBoxGg->ItemIndex=smc.level.block_gg[ix];
   ComboBoxOb->ItemIndex=smc.level.block_ob[ix];
   unsigned char fl=smc.level.block_fl[ix];
   for(int i=0;i<8;i++){
      CheckListBoxFlags->Checked[i]=(fl>>i)&1;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxTileDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 bool sel=State.Contains(odSelected);
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=48; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->Rectangle(0,0,48,64);
 smc.drawblock(kiskep,0,0,smc.level.block_fg[Index],6,8,32,smc.fgblock,smc.fgtile,0x60,sel);
 smc.drawanobj(kiskep,0,0,smc.level.block_ob[Index],sel);
 smc.drawblock(kiskep,0,0,smc.level.block_gg[Index],3,8,32,smc.ggblock,smc.ggtile,0x20,sel);
 kiskep->Canvas->Brush->Color=clWhite;
 kiskep->Canvas->Pen->Color=clBlack;
 if(smc.want_label){
    int x=smc.level.block_ob[Index];
    if(x>0&&x<sizeof(ob)/sizeof(ob[0])) kiskep->Canvas->TextOutA(0,0,ob[x]);
 }
 ComboBoxTile->Canvas->Draw(Rect.left,Rect.top,kiskep);
 delete kiskep;
}
//---------------------------------------------------------------------------


void TSMC::clearsel(){
   int i,j;
   for(i=0;i<3;i++) for(j=0;j<10;j++) sel[i][j]=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxTileChange(TObject *Sender)
{
   if(!open) return;
   int i,j;
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]) smc.level.fg[rm][i][j]=ComboBoxTile->ItemIndex;
   DrawRoom();
   GetTile(ComboBoxTile->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxBackChange(TObject *Sender)
{
   if(!open) return;
   int i,j;
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]) smc.level.bg[rm][i][j]=ComboBoxBack->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxBackDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=24; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->Rectangle(0,0,24,64);
 smc.drawblock(kiskep,0,0,Index,3,8,16,smc.bgblock,smc.bgtile,0x00,State.Contains(odSelected));
 ComboBoxBack->Canvas->Draw(Rect.left,Rect.top,kiskep);
 delete kiskep;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Save1Click(TObject *Sender)
{
 if(!open) return;
 smc.savelevel(level);
 smc.savesmc(file);
}
//---------------------------------------------------------------------------
void TSMC::savelevel(int ix){
   TMemoryStream* ms=ms_data[41+ix];
   TMemoryStream* ms_level=new TMemoryStream;
   ms->Clear();
   ms_level->Write(&level,sizeof(TLevel));
   ms_level->Position=0;
   encodelevel(ms_level,ms,720); // bg
   encodelevel(ms_level,ms,720); // fg
   encodelevel(ms_level,ms,720); // md
   encodelevel(ms_level,ms,256); // block_gg
   encodelevel(ms_level,ms,256); // block_fg
   encodelevel(ms_level,ms,256); // block_ob
   encodelevel(ms_level,ms,256); // block_fl
   encodelevel(ms_level,ms,244); // ...
   encodelevel(ms_level,ms,256); // door1
   encodelevel(ms_level,ms,256); // door2
//   ms_level->SaveToFile("dumplv");
//   ms->SaveToFile("dumplvcmp");
   delete ms_level;
}
//---------------------------------------------------------------------------
void TSMC::encodelevel(TMemoryStream* ms_in,TMemoryStream* ms_out,int len){
   int st=ms_in->Position,en=ms_in->Position+len;
   unsigned char ch,*sp=(unsigned char*)ms_in->Memory+st;
   unsigned char *p=sp,*ep=(unsigned char*)ms_in->Memory+en;
   unsigned char *cp;
   unsigned char dl=0,dt[128],tp;
   unsigned __int16 l[5],sa,ln;
   int i;
   while(p<ep){
      for(i=0;i<5;i++) l[i]=0;
      for(ln=0;p+ln+1<ep&&ln<256;ln++) if(*(p+ln)  !=*(p+ln+1)) break; if(ln>3) l[1]=ln;
      for(ln=0;p+ln+1<ep&&ln<256;ln++) if(*(p+ln)+1!=*(p+ln+1)) break; if(ln>3) l[2]=ln;
      for(ln=0;p+ln+1<ep&&ln<256;ln++) if(*(p+ln)-1!=*(p+ln+1)) break; if(ln>3) l[3]=ln;
      l[4]=0;
      for(cp=sp;cp<p;cp++){
         for(ln=0;ln<256&&p+ln<ep;ln++){
            if(*(p+ln)!=*(cp+ln)) break;
         }
         //ln++;
         if(ln>l[4]&&(ln>4||cp-sp<0xFF&&ln>3)){ sa=cp-sp; l[4]=ln; }
      }
      ln=0; tp=0;
      for(i=1;i<=4;i++) if(l[i]>ln){ ln=l[i]; tp=i; }
      if(ln<2){
         dt[dl++]=*(p++);
         if(dl==0x7F){
            dl+=0x80; ms_out->Write(&dl,1); dl-=0x80;
            ms_out->Write(dt,dl); dl=0;
         }
      }else{
         if(dl){
            dl+=0x80; ms_out->Write(&dl,1); dl-=0x80;
            ms_out->Write(dt,dl); dl=0;
         }
         if(tp==4){
            if(sa>=0x100){
               tp=5; ms_out->Write(&tp,1); ms_out->Write(&ln,1); ms_out->Write(&sa,2);
            }else{
               ms_out->Write(&tp,1); ms_out->Write(&ln,1); ms_out->Write(&sa,1);
            }
         }else{
            ms_out->Write(&tp,1);
            ms_out->Write(&ln,1);
            ms_out->Write(p,1);
         }
         p+=ln;
      }
   }
   if(dl){
      dl+=0x80; ms_out->Write(&dl,1); dl-=0x80;
      ms_out->Write(dt,dl); dl=0;
   }
//   ShowMessage(p-ep);
   ms_in->Position=en;
}
//---------------------------------------------------------------------------
void TSMC::savesmc(AnsiString file){
   unsigned __int32 sa[93];
   unsigned __int16 of; unsigned char sg;
   int i,len;
   ms_smc->Position=0x20000+SMCHD;
   sa[0]=0x20000+ndata*3;
   for(i=1;i<ndata;i++){
      sa[i]=sa[i-1]+ms_data[i-1]->Size;
   }
//   if(sa[91]>lastsa) return ShowMessage("error in savesmc : level too big");
//   sa[91]=lastsa;
   for(i=0;i<ndata;i++){
      of=(sa[i]&0x7FFF)|0x8000; sg=sa[i]>>15;
      ms_smc->Write(&of,2); ms_smc->Write(&sg,1);
   }
   for(i=0;i<ndata-1;i++){
      ms_smc->CopyFrom(ms_data[i],0);
   }
   ms_data[ndata-1]->Position=0;
   len=0x78000+SMCHD-ms_smc->Position; if(len>ms_data[ndata-1]->Size) len=0;
   ms_smc->CopyFrom(ms_data[ndata-1],len);
   ms_smc->SaveToFile(file);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxFgDrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=48; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->Rectangle(0,0,48,64);
 smc.drawblock(kiskep,0,0,Index,6,8,32,smc.fgblock,smc.fgtile,0x60,State.Contains(odSelected));
 ComboBoxFg->Canvas->Draw(Rect.left,Rect.top,kiskep);
 delete kiskep;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxGgDrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=24; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->Rectangle(0,0,24,64);
 smc.drawblock(kiskep,0,0,Index,3,8,32,smc.ggblock,smc.ggtile,0x20,State.Contains(odSelected));
 ComboBoxGg->Canvas->Draw(Rect.left,Rect.top,kiskep);
 delete kiskep;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxFgChange(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('f');
   smc.level.block_fg[ComboBoxTile->ItemIndex]=ComboBoxFg->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxGgChange(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('g');
   smc.level.block_gg[ComboBoxTile->ItemIndex]=ComboBoxGg->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxObChange(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('o');
   smc.level.block_ob[ComboBoxTile->ItemIndex]=ComboBoxOb->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Starthere1Click(TObject *Sender)
{
   smc.level.start_rm=rm;
   smc.level.start_ps=lasti*10+lastj;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Guardhere1Click(TObject *Sender)
{
   smc.level.guard_ps[rm]=lasti*10+lastj;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Deleteguard1Click(TObject *Sender)
{
   smc.level.guard_ps[rm]=255;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Flipstart1Click(TObject *Sender)
{
   smc.level.start_dr=smc.level.start_dr?0:255;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Flipguard1Click(TObject *Sender)
{
   smc.level.guard_tp[rm]^=0x80;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Guardtype1Click(TObject *Sender)
{
   int x=smc.level.guard_tp[rm],tp=x&0x7F;
/*   AnsiString s=InputBox("Guard","Guard","0");
   try{x=StrToInt(s);}catch(...){x=0;}*/
   tp=Select(gu,sizeof(gu)/sizeof(gu[0]),tp,"Select guard type");
   x=x&0x80|tp;
   smc.level.guard_tp[rm]=x;
   DrawRoom();
}
//---------------------------------------------------------------------------
int TForm1::Select(const char* list[],int n,int def,AnsiString s){
   int i;
   TForm* dform; TListBox* dlist; TButton* dok,*dcan;
   dform=new TForm(Application);
   dlist=new TListBox(Application);
   dok=new TButton(Application);
   dcan=new TButton(Application);
   dlist->Parent=dform;
   dok->Parent=dform;
   dcan->Parent=dform;
   dform->Caption=s;
   for(i=0;i<n;i++) dlist->Items->Add(list[i]);
   dlist->ItemIndex=def;
   dlist->Height=(dlist->ItemHeight+1)*n;
   dok->Left=0; dok->Top=dlist->Height; dok->Caption="OK";
   dok->ModalResult=mrOk; dok->Default=true; dok->Width=dlist->Width/2;
   dcan->Left=dlist->Width/2; dcan->Top=dlist->Height; dcan->Caption="Cancel";
   dcan->ModalResult=mrCancel; dcan->Cancel=true; dcan->Width=dlist->Width/2;
   dform->AutoSize=true;
   dform->Position=poMainFormCenter;
   dform->BorderIcons=TBorderIcons();
   dform->BorderStyle=bsSingle;
   if(dform->ShowModal()==mrOk){
      i=dlist->ItemIndex;
   }else{
      i=def;
   }
   delete dlist;
   delete dok;
   delete dcan;
   delete dform;
   return i;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Guardskill1Click(TObject *Sender)
{
   int x=smc.level.guard_sk[rm];
   AnsiString s=InputBox("skill","skill",IntToStr(x));
   try{x=StrToInt(s);}catch(...){}
   smc.level.guard_sk[rm]=x;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Roomlinks1Click(TObject *Sender)
{
   TForm* dform; TButton* dok,*dcan; TEdit* dl,*dr,*du,*dd;
   dform=new TForm(Application);
   dform->Caption="Room links";
   dform->Width=150; dform->Height=200;
   dok=new TButton(Application); dok->Parent=dform; dok->Caption="OK"; dok->Width=50;
   dok->Left=10; dok->Top=120; dok->Default=true; dok->ModalResult=mrOk;
   dcan=new TButton(Application); dcan->Parent=dform; dcan->Caption="Cancel"; dcan->Width=50;
   dcan->Left=60; dcan->Top=120; dcan->Cancel=true; dcan->ModalResult=mrCancel;
   dl=new TEdit(Application); dl->Parent=dform; dl->Left=10; dl->Top=50; dl->Width=30;
   dr=new TEdit(Application); dr->Parent=dform; dr->Left=90; dr->Top=50; dr->Width=30;
   du=new TEdit(Application); du->Parent=dform; du->Left=50; du->Top=10; du->Width=30;
   dd=new TEdit(Application); dd->Parent=dform; dd->Left=50; dd->Top=90; dd->Width=30;
   dform->Position=poMainFormCenter;
   dform->BorderIcons=TBorderIcons();
   dform->BorderStyle=bsSingle;
   dl->Text=IntToStr(smc.level.rm_links[rm][0]);
   dr->Text=IntToStr(smc.level.rm_links[rm][1]);
   du->Text=IntToStr(smc.level.rm_links[rm][2]);
   dd->Text=IntToStr(smc.level.rm_links[rm][3]);
   if(dform->ShowModal()==mrOk){
      smc.level.rm_links[rm][0]=StrToInt(dl->Text);
      smc.level.rm_links[rm][1]=StrToInt(dr->Text);
      smc.level.rm_links[rm][2]=StrToInt(du->Text);
      smc.level.rm_links[rm][3]=StrToInt(dd->Text);
      DrawRoom();
   }
   delete dok; delete dcan; delete dl; delete dr; delete du; delete dd;
   delete dform;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxModChange(TObject *Sender)
{
   if(!open) return;
   int i,j;
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]) smc.level.md[rm][i][j]=ComboBoxMod->ItemIndex;
   GetMod(ComboBoxMod->ItemIndex);
   DrawRoom();
}
//---------------------------------------------------------------------------
void TForm1::GetMod(int ix){
   unsigned char ch1=smc.level.door1[ix],ch2=smc.level.door2[ix];
   int rm=(ch1&0x60)>>5|(ch2&0xE0)>>3;
   int ti=ch1&0x1F;
   bool nx=ch1>>7;
   open=false;
   EditRm->Text=IntToStr(rm);
   EditPs->Text=IntToStr(ti);
   CheckBoxNx->Checked=nx;
   open=true;
}
//---------------------------------------------------------------------------
void TForm1::SetMod(int ix){
   unsigned char ch1,ch2;
   try{
      int rm=StrToInt(EditRm->Text);
      int ti=StrToInt(EditPs->Text);
      bool nx=CheckBoxNx->Checked;
      ch1=ti&0x1F|(rm&3)<<5|nx<<7;
      ch2=(rm&0x1C)<<3;
      smc.level.door1[ix]=ch1; smc.level.door2[ix]=ch2;
   }catch(...){GetMod(ix);}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditRmChange(TObject *Sender)
{
   if(open) SetMod(ComboBoxMod->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditPsChange(TObject *Sender)
{
   if(open) SetMod(ComboBoxMod->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBoxNxClick(TObject *Sender)
{
   if(open) SetMod(ComboBoxMod->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckListBoxFlagsClick(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('F');
   unsigned char fl=0;
   for(int i=0;i<8;i++){
      if(CheckListBoxFlags->Checked[i]) fl|=1<<i;
   }
   smc.level.block_fl[ComboBoxTile->ItemIndex]=fl;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Export1Click(TObject *Sender)
{
 if(!open) return;
 if(SaveDialogExport->Execute()){
    TMemoryStream* ms=new TMemoryStream;
    ms->Write(&smc.level,sizeof(TLevel));
    ms->SaveToFile(SaveDialogExport->FileName);
    delete ms;
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Import1Click(TObject *Sender)
{
 if(!open) return;
 if(OpenDialogImport->Execute()){
    TMemoryStream* ms=new TMemoryStream;
    ms->LoadFromFile(OpenDialogImport->FileName);
    ms->Read(&smc.level,sizeof(TLevel));
    delete ms;
    rm=smc.level.start_rm;
    DrawRoom();
 }
}
//---------------------------------------------------------------------------
void TSMC::drawsprite(Graphics::TBitmap* bm,int x0,int y0,int ix,int pi,bool flip,bool sel){
   unsigned __int16 of; unsigned char sg,wh,hh,rw,rh;
   int sa; unsigned char* tile;
   ms_smc->Position=0x78000+SMCHD+ix*3;
   ms_smc->Read(&of,2);
   ms_smc->Read(&sg,1);
   sa=(sg<<15)|(of&0x7FFF);
   ms_smc->Position=sa+SMCHD;
   decodesprite(ms_smc,&tile,&wh,&hh,&rw,&rh);
   ms_data[68]->Position=pi<<5;
   TColor* mypal;
   decodepal(ms_data[68],&mypal,16);
   memcpy(pal+128,mypal,16*sizeof(TColor));
   brightpal(pal,pal2,256);
   delete[]mypal;
   int i,j,i2,j2,tix=0;
   for(i=0;i<hh;i++){
      for(j=0;j<wh;j++){
         for(i2=0;i2<2;i2++){
            for(j2=0;j2<2;j2++){
               if(flip){
                  drawtile(bm,x0/*+rw*/-(j<<4)-(j2<<3),y0+(i<<4)+(i2<<3),(tix++)^0x4000,32,tile,0x80,sel);
               }else{
                  drawtile(bm,x0+(j<<4)+(j2<<3),y0+(i<<4)+(i2<<3),tix++,32,tile,0x80,sel);
               }
            }
         }
      }
   }
   delete[]tile;
}
//---------------------------------------------------------------------------
void TSMC::decodesprite(TMemoryStream* ms_in,unsigned char**tile,unsigned char*wh,unsigned char*hh,unsigned char*rw,unsigned char*rh){
   unsigned char x,mm,m,o,ch; int i,l,b,ix=0;
   unsigned char const ly[]={0x00,0x01,0x10,0x11,0x20,0x21,0x30,0x31};
   unsigned char ar[64];
   bool fill;
   ms_in->Read(rw,1);
   ms_in->Read(rh,1);
   ms_in->Read(&x,1);
   *hh=x>>4; *wh=x&15;
   *tile=new unsigned char[(*wh)*(*hh)*128];
   for(i=0;i<(*wh)*(*hh)*2;i++){
      ms_in->Read(&mm,1);
      memset(ar,0,64);
      for(l=0;l<8;l++){
         if(!(mm&1<<l)) continue;
         o=ly[l];
         fill=false;
         ms_in->Read(&m,1); if(m==255){ms_in->Read(&m,1);fill=true;}
         if(fill){
            ms_in->Read(&ch,1);
            for(b=0;b<8;b++){
               if(!(m&1<<b)) ar[(b<<1)+o]=ch;
            }
         }else{
            for(b=0;b<8;b++){
               if(!(m&1<<b)) ms_in->Read(&(ar[(b<<1)+o]),1);
            }
         }
      }
      memcpy(*tile+((ix++)<<6),ar,64);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Automatic1Click(TObject *Sender)
{
 Automatic1->Checked=true;
 amode=true;
 //ComboBoxTile->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Manual1Click(TObject *Sender)
{
 Manual1->Checked=true;
 amode=false;
 //ComboBoxTile->Enabled=true;
}
//---------------------------------------------------------------------------

void TForm1::DoAuto(int what){
   unsigned char fg1=ComboBoxFg->ItemIndex,gg1=ComboBoxGg->ItemIndex,
      ob1=ComboBoxOb->ItemIndex,fl1=0,fg,gg,ob,fl=0;
   int i,j,t,rm2,s,o; bool u[256];
   for(i=0;i<8;i++){
      if(CheckListBoxFlags->Checked[i]) fl1|=1<<i;
   }
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]){
      t=smc.level.fg[rm][i][j];
      fg=smc.level.block_fg[t];
      gg=smc.level.block_gg[t];
      ob=smc.level.block_ob[t];
      fl=smc.level.block_fl[t];
      switch(what){
         case 'f': fg=fg1; break;
         case 'g': gg=gg1; break;
         case 'o': ob=ob1; break;
         case 'F': fl=fl1; break;
      }
      smc.level.fg[rm][i][j]=0;
      for(t=0;t<256;t++){
         if(smc.level.block_fg[t]==fg&&smc.level.block_gg[t]==gg&&
            smc.level.block_ob[t]==ob&&smc.level.block_fl[t]==fl) break;
      }
      if(t<256){
         smc.level.fg[rm][i][j]=t;
      }else{
         for(t=0;t<256;t++) u[t]=false;
         for(rm2=0;rm2<24;rm2++) for(s=0;s<3;s++) for(o=0;o<10;o++) u[smc.level.fg[rm2][s][o]]=true;
         for(t=1;t<255;t++) if(!u[t]) break;
         if(t<255){
            smc.level.block_fg[t]=fg;
            smc.level.block_gg[t]=gg;
            smc.level.block_ob[t]=ob;
            smc.level.block_fl[t]=fl;
            smc.level.fg[rm][i][j]=t;
         }else{
            ShowMessage("No room for tile!");
         }
      }
   }
   DrawRoom();
}
//---------------------------------------------------------------------------
void TSMC::decodeobj(TMemoryStream* ms_in,unsigned char**tile){
   unsigned char const ly[]={0x00,0x01,0x10,0x11,0x20,0x21,0x30,0x31};
   unsigned __int16 sa[6]; int i,j,y,c,p0=ms_in->Position;
   unsigned char ch,m,dt[4];
   *tile=new unsigned char[6*4*64];
   memset(*tile,0,6*4*64);
   for(i=0;i<6;i++) ms_in->Read(&sa[i],2);
   for(i=0;i<6;i++){
      if(sa[i]){
         ms_in->Position=p0+sa[i];
         for(y=0;y<64;){
            ms_in->Read(&ch,1);
            if(ch>>7){
               y+=ch&0x7F;
            }else{
               for(j=0;j<ch;j++){
                  ms_in->Read(&m,1);
                  ms_in->Read(&dt,4);
                  for(c=0;c<4;c++){
                     (*tile)[i*4*64+(y>>3<<5)+((y&7)<<1)+ly[c]]=dt[c];
                  }
                  y++;
               }
            }
         }
      }
   }
}
//---------------------------------------------------------------------------
void TSMC::drawobj(Graphics::TBitmap* bm,int x0,int y0,int ix,bool sel){
   unsigned __int16 of; unsigned char sg;
   int sa,x,y,ti; unsigned char* tile;
   ms_smc->Position=0x78000+SMCHD+ix*3;
   ms_smc->Read(&of,2);
   ms_smc->Read(&sg,1);
   sa=(sg<<15)|(of&0x7FFF);
   ms_smc->Position=sa+SMCHD;
   decodeobj(ms_smc,&tile);
   ti=0;
   for(x=0;x<6;x++){
      for(y=0;y<8;y++){
         drawtile(bm,x0+(x<<3),y0+(y<<3),ti++,32,tile,0x60,sel);
      }
   }
   delete[]tile;
}
//---------------------------------------------------------------------------
void TSMC::drawanobj(Graphics::TBitmap* bm,int x0,int y0,unsigned char ch,bool sel){
   int lt=ltype; if(lt==9) lt=6;
   int T0Bx[]={31,28,28,28,28,28,31,32,31,31};
   int T1Dx[]={23, 8,32, 0,36,28,29,23,23,23};
   int T21x[]={23, 8, 2, 0,36,28,37,23,23,23};
   int T22x[]={23, 8,32, 0,36,36,36,23,23,23};

   int T0By[]={ 1, 0, 0, 0, 0, 0,-7,-16, 0, 0};
   int T1Dy[]={ 0, 0, 0, 0, 0,-8,-8, 0, 0, 0};
   int T21y[]={ 0, 0, 2, 0, 0,16,-8, 0, 0, 0};
   int T22y[]={ 0, 0, 0, 0, 0,-8, 0, 0, 0, 0};
   if(lt==4&&Form1->level==14&&(Form1->rm==15||Form1->rm==18)&&
      (ch==0x02||ch==0x04||ch==0x05||ch==0x17)) lt=7; // blue
   switch(ch){
      case 0x02: // loose floor
      drawobj(bm,x0,y0,1252+lt*6,sel);
      break;
      case 0x04: // door opener
      drawobj(bm,x0,y0,1250+lt*6,sel);
      break;
      case 0x05: // door closer
      drawobj(bm,x0,y0,1251+lt*6,sel);
      break;
      case 0x06: // door
      drawobj(bm,x0,y0,1359,sel);
      break;
      case 0x07: // level door (end)
      drawobj(bm,x0,y0-16,1297+lt,sel);
      break;
      case 0x08: // mirror
      drawobj(bm,x0,y0,1370,sel);
      break;
      case 0x09: // skeleton
      drawobj(bm,x0,y0,1371,sel);
      break;
      case 0x0A: // sword
      drawsprite(bm,x0,y0+50,697,22,false,sel);
      break;
      case 0x0B: // torch
      drawtorch(bm,x0+T0Bx[lt],y0+T0By[lt],sel);
      break;
      case 0x0C: // chomper
      drawobj(bm,x0,y0,1308,sel);
      break;
      case 0x0D: // guillotine
      drawobj(bm,x0,y0,1315,sel);
      break;
      case 0x0E: // spike
      drawobj(bm,x0,y0,1345,sel);
      break;
      case 0x10: // crusher
      drawobj(bm,x0,y0,1373,sel);
      break;
      case 0x12: // heal potion
      drawsprite(bm,x0+16,y0+38,1089,24,false,sel);
      break;
      case 0x13: // life potion
      drawsprite(bm,x0+16,y0+40,1088,24,false,sel);
      break;
      case 0x14: // hurt potion
      drawsprite(bm,x0+16,y0+38,1093,24,false,sel);
      break;
      case 0x15: // upside down potion
      drawsprite(bm,x0+16,y0+40,1088,24,false,sel);
      break;
      case 0x16: // slow fall potion
      drawsprite(bm,x0+16,y0+40,1088,24,false,sel);
      break;
      case 0x17: // debris
      drawobj(bm,x0,y0,1254+lt*6,sel);
      break;
      case 0x19: // fire
      drawobj(bm,x0,y0,1386,sel);
      break;
      case 0x1A: // potion of warp
      drawsprite(bm,x0+16,y0+40,1088,24,false,sel);
      break;
      case 0x1C: // kill potion
      drawsprite(bm,x0+16,y0+40,1088,24,false,sel);
      break;
      case 0x1D: // torch
      drawtorch(bm,x0+T1Dx[lt],y0+T1Dy[lt],sel);
      break;
      case 0x1E: // log
      drawobj(bm,x0,y0,1336,sel);
      break;
      case 0x20: // stars
      drawobj(bm,x0,y0,1348,sel);
      break;
      case 0x21: // torch
      drawtorch(bm,x0+T21x[lt],y0+T21y[lt],sel);
      break;
      case 0x22: // torch
      drawtorch(bm,x0+T22x[lt],y0+T22y[lt],sel);
      break;
      case 0x24: // level door (begin)
      drawobj(bm,x0,y0-16,1297+lt,sel);
      break;
      case 0x2A: // conveyor belt >>>
      drawobj(bm,x0,y0,1388,sel);
      break;
      case 0x2B: // conveyor belt <<<
      drawobj(bm,x0,y0,1388,sel);
      break;
   }
}
//---------------------------------------------------------------------------
void TSMC::drawtorch(Graphics::TBitmap* bm,int x0,int y0,bool sel){
   TColor* mypal;
   ms_data[68]->Position=23<<5;
   decodepal(ms_data[68],&mypal,16);
   memcpy(pal+128,mypal,16*sizeof(TColor));
   brightpal(pal,pal2,256);
   delete[]mypal;
   drawtile(bm,x0,y0,0,32,(unsigned char*)ms_data[73]->Memory,0x80,sel);
   drawtile(bm,x0,y0+8,1,32,(unsigned char*)ms_data[73]->Memory,0x80,sel);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Labels1Click(TObject *Sender)
{
   Labels1->Checked=smc.want_label=!smc.want_label;
   if(!open) return;
   DrawRoom();
   ComboBoxTile->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Clearallrooms1Click(TObject *Sender)
{
 if(Application->MessageBox("Do you really want to clear all rooms?","Clear all rooms",MB_YESNO)==IDYES){
    memset(&smc.level,0,sizeof(smc.level));
    memset(&smc.level.rm_links,255,sizeof(smc.level.rm_links));
    memset(&smc.level.guard_ps,255,sizeof(smc.level.guard_ps));
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Clearthisroom1Click(TObject *Sender)
{
 if(Application->MessageBox("Do you really want to clear this room?","Clear this room",MB_YESNO)==IDYES){
    memset(&smc.level.bg[rm],0,sizeof(smc.level.bg[rm]));
    memset(&smc.level.fg[rm],0,sizeof(smc.level.fg[rm]));
    memset(&smc.level.md[rm],0,sizeof(smc.level.md[rm]));
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Jumptoroom1Click(TObject *Sender)
{
 AnsiString s=IntToStr(rm);
 int rm2=rm;
 s=InputBox("Which room do you want to jump to? (0-23)","Jump to room",s);
 try{
    rm2=StrToInt(s);
 }catch(...){
    //
 }
 if(rm2>=0 && rm2<=23){
    rm=rm2;
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Changetype1Click(TObject *Sender)
{
 int lt=Select(ltypes,sizeof(ltypes)/sizeof(ltypes[0]),smc.ltype,"Change level type");
 *((char*)smc.ms_smc->Memory+0x36EE+SMCHD+level)=smc.ltype=lt;
 smc.openenv(lt);
 DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Doublesize1Click(TObject *Sender)
{
   Doublesize1->Checked=!Doublesize1->Checked;
   scale=Doublesize1->Checked?2:1;
   PaintBox1->OnPaint(NULL);
   ButtonUp->Top=Panel1->Height-2;
   PaintBox1->Top=ButtonUp->Top+ButtonUp->Height;
   ButtonUp->Left=PaintBox1->Left+PaintBox1->Width/2-ButtonUp->Width/2;
   ButtonLeft->Top=PaintBox1->Top+PaintBox1->Height/2-ButtonUp->Height/2;
   ButtonDown->Left=PaintBox1->Left+PaintBox1->Width/2-ButtonUp->Width/2;
   ButtonRight->Top=PaintBox1->Top+PaintBox1->Height/2-ButtonUp->Height/2;
   ButtonRight->Left=PaintBox1->Left+PaintBox1->Width+20;
   ButtonDown->Top=PaintBox1->Top+PaintBox1->Height+0;
}
//---------------------------------------------------------------------------

